<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Loja de game</title>
    <hr>
    <h2>Login</h2>
    <input type="text" name="nmEmail" id="idEmail" placeholder="a@b.com"><br>
    <input type="password" name="nmPassword" id="idPassword" placeholder="******"><br>
    <button type="button" onclick="login()">Logar</button>
    <hr>
    <h4>Lista de Games</h4>
    <ul id="lstGames"></ul>
    <hr>
    <h4>Novo Game</h4>
    <input type="text" name="nmTitle" id="idTitle" placeholder="Título"><br>
    <input type="number" name="nmYear" id="idYear" placeholder="Ano"><br>
    <input type="number" name="nmPrice" id="idPrice" placeholder="Preço"><br>
    <button type="button" onclick="createGame()">Criar</button>
    <hr>
    <h4>Editar Game</h4>
    <input type="text" name="nmIdEdt" id="idIdEdt" placeholder="ID" readonly><br>
    <input type="text" name="nmTitleEdt" id="idTitleEdt" placeholder="Título"><br>
    <input type="number" name="nmYearEdt" id="idYearEdt" placeholder="Ano"><br>
    <input type="number" name="nmPriceEdt" id="idPriceEdt" placeholder="Preço"><br>
    <button type="button" onclick="updateGame()">Editar</button>
</head>
<body>

</body>

<script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>    

<script>
    var axiosConfig = {
        headers: {
            Authorization: "Bearer " + localStorage.getItem("AuthToken")
        }
    }

    function login(){
        var vEmailInput = document.getElementById("idEmail");
        var vPasswordInput = document.getElementById("idPassword");

        var vEmail = vEmailInput.value;
        var vPassword = vPasswordInput.value;

        axios.post("http://localhost:45678/auth", {
            email: vEmail,
            password: vPassword
        }).then(res => {
            var vToken = res.data.token;
            //Armazena o token no localStorage do browser
            localStorage.setItem("AuthToken", vToken);

            axiosConfig.headers.Authorization = "Bearer " + localStorage.getItem("AuthToken");
            
            alert("Login efetuado");
        }).catch(err => {
            alert("Usuário não authorizado");
        });
    }

    function createGame(){
        var vTitleInput = document.getElementById("idTitle");
        var vYearInput = document.getElementById("idYear");
        var vPriceInput = document.getElementById("idPrice");

        //Atenção para o nome dos campos do json. Deve ser o mesmo definido na API
        var game = {
            title: vTitleInput.value,
            year: vYearInput.value,
            price: vPriceInput.value
        }

        axios.post("http://localhost:45678/game", game, axiosConfig).then(response => {
            if(response.status == 200){
                alert("Game Cadastrado");
            }
        }).catch(error => {
            console.log(error);
        });
    }

    function deleteGame(listItem){
        var vId = listItem.getAttribute("data-id");

        axios.delete("http://localhost:45678/game/"+vId, axiosConfig).then(response => {
            alert("Game Deletado.")
        }).catch(err => {
            console.log(err);
        });
    }

    function loadGame(listItem){
        console.log(listItem);

        var vId = listItem.getAttribute("data-id");
        var vTitle = listItem.getAttribute("data-title");
        var vYear = listItem.getAttribute("data-year");
        var vPrice = listItem.getAttribute("data-price");

        document.getElementById("idIdEdt").value = vId;
        document.getElementById("idTitleEdt").value = vTitle;
        document.getElementById("idYearEdt").value = vYear;
        document.getElementById("idPriceEdt").value = vPrice;

    }

    function updateGame(){
        var vIdInput = document.getElementById("idIdEdt");
        var vTitleInput = document.getElementById("idTitleEdt");
        var vYearInput = document.getElementById("idYearEdt");
        var vPriceInput = document.getElementById("idPriceEdt");

        //Atenção para o nome dos campos do json. Deve ser o mesmo definido na API
        var game = {
            title: vTitleInput.value,
            year: vYearInput.value,
            price: vPriceInput.value
        }

        var vId = vIdInput.value;
        axios.put("http://localhost:45678/game/"+vId, game, axiosConfig).then(response => {
            if(response.status == 200){
                alert("Game Atualized");
            }
        }).catch(error => {
            console.log(error);
        });
    }

    axios.get("http://localhost:45678/games", axiosConfig).then(response => {
        var vGames = response.data;
        var vList = document.getElementById("lstGames");

        vGames.forEach(g => {
            var vItem = document.createElement("li");

            vItem.setAttribute("data-id", g.id);
            vItem.setAttribute("data-title", g.title);
            vItem.setAttribute("data-year", g.year);
            vItem.setAttribute("data-price", g.price);

            vItem.innerHTML = g.id + " - " + g.title + " - $ " + g.price;

            // Botão deletar
            var vDeleteBtn = document.createElement("button");
            vDeleteBtn.innerHTML = "Deletar";
            vDeleteBtn.addEventListener("click", function() {
                deleteGame(vItem);
            });
            vItem.appendChild(vDeleteBtn);

            // Botão editar
            var vEditarBtn = document.createElement("button");
            vEditarBtn.innerHTML = "Editar";
            vEditarBtn.addEventListener("click", function(){
                loadGame(vItem);
            });
            vItem.appendChild(vEditarBtn);

            //
            vList.appendChild(vItem);
        });
    }).catch(error => {
        console.log(error);
    });
</script>


</html>